// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: service_items.sql

package db

import (
	"context"
	"database/sql"
)

const createService_item = `-- name: CreateService_item :one
INSERT INTO service_items (
    name,
    code,
    price
) VALUES (
    $1, $2, $3
) RETURNING id, name, code, price
`

type CreateService_itemParams struct {
	Name  string        `json:"name"`
	Code  string        `json:"code"`
	Price sql.NullInt64 `json:"price"`
}

func (q *Queries) CreateService_item(ctx context.Context, arg CreateService_itemParams) (ServiceItems, error) {
	row := q.db.QueryRowContext(ctx, createService_item, arg.Name, arg.Code, arg.Price)
	var i ServiceItems
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.Code,
		&i.Price,
	)
	return i, err
}

const deleteService_item = `-- name: DeleteService_item :exec
DELETE FROM service_items WHERE id = $1
`

func (q *Queries) DeleteService_item(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deleteService_item, id)
	return err
}

const getService_item = `-- name: GetService_item :one
SELECT id, name, code, price FROM service_items
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetService_item(ctx context.Context, id int64) (ServiceItems, error) {
	row := q.db.QueryRowContext(ctx, getService_item, id)
	var i ServiceItems
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.Code,
		&i.Price,
	)
	return i, err
}

const listService_items = `-- name: ListService_items :many
SELECT id, name, code, price FROM service_items
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListService_itemsParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListService_items(ctx context.Context, arg ListService_itemsParams) ([]ServiceItems, error) {
	rows, err := q.db.QueryContext(ctx, listService_items, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []ServiceItems
	for rows.Next() {
		var i ServiceItems
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.Code,
			&i.Price,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateService_item = `-- name: UpdateService_item :exec
UPDATE service_items 
SET price = $2
WHERE id = $1
`

type UpdateService_itemParams struct {
	ID    int64         `json:"id"`
	Price sql.NullInt64 `json:"price"`
}

func (q *Queries) UpdateService_item(ctx context.Context, arg UpdateService_itemParams) error {
	_, err := q.db.ExecContext(ctx, updateService_item, arg.ID, arg.Price)
	return err
}
